Index: kernel/arch/sparc64/include/arch/types.h
===================================================================
--- kernel/arch/sparc64/include/arch/types.h	(revision 2b11c3c0cf74426080bd899202376055d7cb591d)
+++ kernel/arch/sparc64/include/arch/types.h	(revision f834dd816464592376050320f24119ef2aabf8e8)
@@ -36,17 +36,5 @@
 #define KERN_sparc64_TYPES_H_
 
-#include <arch/common.h>
-
-typedef uint64_t size_t;
-typedef int64_t ssize_t;
-
-typedef uint64_t uintptr_t;
-typedef uint64_t pfn_t;
-
-typedef uint64_t ipl_t;
-
-typedef uint64_t sysarg_t;
-typedef int64_t native_t;
-typedef uint64_t atomic_count_t;
+#include <_bits/all.h>
 
 typedef struct {
@@ -55,9 +43,4 @@
 typedef uint8_t asi_t;
 
-#define PRIdn  PRId64  /**< Format for native_t. */
-#define PRIun  PRIu64  /**< Format for sysarg_t. */
-#define PRIxn  PRIx64  /**< Format for hexadecimal sysarg_t. */
-#define PRIua  PRIu64  /**< Format for atomic_count_t. */
-
 #endif
 
Index: kernel/generic/include/stddef.h
===================================================================
--- kernel/generic/include/stddef.h	(revision 2b11c3c0cf74426080bd899202376055d7cb591d)
+++ kernel/generic/include/stddef.h	(revision f834dd816464592376050320f24119ef2aabf8e8)
@@ -38,9 +38,5 @@
 #include <arch/types.h>
 
-typedef native_t ptrdiff_t;
-
-#ifndef NULL
-	#define NULL  ((void *) 0)
-#endif
+#include <_bits/NULL.h>
 
 #define offsetof(type,member) ((size_t) &(((type *) 0)->member))
Index: kernel/generic/include/stdint.h
===================================================================
--- kernel/generic/include/stdint.h	(revision 2b11c3c0cf74426080bd899202376055d7cb591d)
+++ kernel/generic/include/stdint.h	(revision f834dd816464592376050320f24119ef2aabf8e8)
@@ -36,29 +36,5 @@
 #define KERN_STDINT_H_
 
-#include <arch/common.h>
-
-#define INT8_MIN  INT8_C(0x80)
-#define INT8_MAX  INT8_C(0x7F)
-
-#define UINT8_MIN  UINT8_C(0)
-#define UINT8_MAX  UINT8_C(0xFF)
-
-#define INT16_MIN  INT16_C(0x8000)
-#define INT16_MAX  INT16_C(0x7FFF)
-
-#define UINT16_MIN  UINT16_C(0)
-#define UINT16_MAX  UINT16_C(0xFFFF)
-
-#define INT32_MIN  INT32_C(0x80000000)
-#define INT32_MAX  INT32_C(0x7FFFFFFF)
-
-#define UINT32_MIN  UINT32_C(0)
-#define UINT32_MAX  UINT32_C(0xFFFFFFFF)
-
-#define INT64_MIN  INT64_C(0x8000000000000000)
-#define INT64_MAX  INT64_C(0x7FFFFFFFFFFFFFFF)
-
-#define UINT64_MIN  UINT64_C(0)
-#define UINT64_MAX  UINT64_C(0xFFFFFFFFFFFFFFFF)
+#include <_bits/stdint.h>
 
 #endif
Index: kernel/generic/include/synch/mutex.h
===================================================================
--- kernel/generic/include/synch/mutex.h	(revision 2b11c3c0cf74426080bd899202376055d7cb591d)
+++ kernel/generic/include/synch/mutex.h	(revision f834dd816464592376050320f24119ef2aabf8e8)
@@ -43,10 +43,15 @@
 typedef enum {
 	MUTEX_PASSIVE,
+	MUTEX_RECURSIVE,
 	MUTEX_ACTIVE
 } mutex_type_t;
+
+struct thread;
 
 typedef struct {
 	mutex_type_t type;
 	semaphore_t sem;
+	struct thread *owner;
+	unsigned nesting;
 } mutex_t;
 
Index: kernel/generic/include/typedefs.h
===================================================================
--- kernel/generic/include/typedefs.h	(revision 2b11c3c0cf74426080bd899202376055d7cb591d)
+++ kernel/generic/include/typedefs.h	(revision f834dd816464592376050320f24119ef2aabf8e8)
@@ -36,6 +36,4 @@
 #define KERN_TYPEDEFS_H_
 
-#include <stdint.h>
-#include <arch/common.h>
 #include <arch/types.h>
 
Index: kernel/generic/src/cap/cap.c
===================================================================
--- kernel/generic/src/cap/cap.c	(revision 2b11c3c0cf74426080bd899202376055d7cb591d)
+++ kernel/generic/src/cap/cap.c	(revision f834dd816464592376050320f24119ef2aabf8e8)
@@ -84,6 +84,4 @@
 
 static slab_cache_t *cap_slab;
-
-static kobject_t *cap_unpublish_locked(task_t *, cap_handle_t, kobject_type_t);
 
 static size_t caps_hash(const ht_link_t *item)
@@ -150,5 +148,5 @@
 void caps_task_init(task_t *task)
 {
-	mutex_initialize(&task->cap_info->lock, MUTEX_PASSIVE);
+	mutex_initialize(&task->cap_info->lock, MUTEX_RECURSIVE);
 
 	for (kobject_type_t t = 0; t < KOBJECT_TYPE_MAX; t++)
@@ -240,5 +238,5 @@
 	if (cap->state == CAP_STATE_PUBLISHED && cap->kobject->ops->reclaim &&
 	    cap->kobject->ops->reclaim(cap->kobject)) {
-		kobject_t *kobj = cap_unpublish_locked(cap->task, cap->handle,
+		kobject_t *kobj = cap_unpublish(cap->task, cap->handle,
 		    cap->kobject->type);
 		kobject_put(kobj);
@@ -320,9 +318,21 @@
 }
 
-static kobject_t *
-cap_unpublish_locked(task_t *task, cap_handle_t handle, kobject_type_t type)
+/** Unpublish published capability
+ *
+ * The kernel object is moved out of the capability. In other words, the
+ * capability's reference to the objects is handed over to the kernel object
+ * pointer returned by this function. Once unpublished, the capability does not
+ * refer to any kernel object anymore.
+ *
+ * @param task    Task in which to unpublish the capability.
+ * @param handle  Capability handle.
+ * @param type    Kernel object type of the object associated with the
+ *                capability.
+ */
+kobject_t *cap_unpublish(task_t *task, cap_handle_t handle, kobject_type_t type)
 {
 	kobject_t *kobj = NULL;
 
+	mutex_lock(&task->cap_info->lock);
 	cap_t *cap = cap_get(task, handle, CAP_STATE_PUBLISHED);
 	if (cap) {
@@ -335,25 +345,4 @@
 		}
 	}
-
-	return kobj;
-}
-
-/** Unpublish published capability
- *
- * The kernel object is moved out of the capability. In other words, the
- * capability's reference to the objects is handed over to the kernel object
- * pointer returned by this function. Once unpublished, the capability does not
- * refer to any kernel object anymore.
- *
- * @param task    Task in which to unpublish the capability.
- * @param handle  Capability handle.
- * @param type    Kernel object type of the object associated with the
- *                capability.
- */
-kobject_t *cap_unpublish(task_t *task, cap_handle_t handle, kobject_type_t type)
-{
-
-	mutex_lock(&task->cap_info->lock);
-	kobject_t *kobj = cap_unpublish_locked(task, handle, type);
 	mutex_unlock(&task->cap_info->lock);
 
Index: kernel/generic/src/debug/panic.c
===================================================================
--- kernel/generic/src/debug/panic.c	(revision 2b11c3c0cf74426080bd899202376055d7cb591d)
+++ kernel/generic/src/debug/panic.c	(revision f834dd816464592376050320f24119ef2aabf8e8)
@@ -62,5 +62,5 @@
 		printf("\n");
 	} else if (cat == PANIC_BADTRAP) {
-		printf("bad trap %" PRIun ". %s\n", address,
+		printf("bad trap %" PRIuPTR ". %s\n", address,
 		    BANNER_RIGHT);
 		if (fmt) {
@@ -96,5 +96,5 @@
 	printf("THE=%p: ", THE);
 	if (THE != NULL) {
-		printf("pe=%" PRIun " thread=%p task=%p cpu=%p as=%p"
+		printf("pe=%" PRIuPTR " thread=%p task=%p cpu=%p as=%p"
 		    " magic=%#" PRIx32 "\n", THE->preemption,
 		    THE->thread, THE->task, THE->cpu, THE->as, THE->magic);
Index: kernel/generic/src/ipc/ipc.c
===================================================================
--- kernel/generic/src/ipc/ipc.c	(revision 2b11c3c0cf74426080bd899202376055d7cb591d)
+++ kernel/generic/src/ipc/ipc.c	(revision f834dd816464592376050320f24119ef2aabf8e8)
@@ -97,4 +97,6 @@
 		if (call->buffer)
 			free(call->buffer);
+		if (call->caller_phone)
+			kobject_put(call->caller_phone->kobject);
 		slab_free(call_slab, call);
 	}
@@ -346,4 +348,5 @@
 
 	call->caller_phone = phone;
+	kobject_add_ref(phone->kobject);
 
 	if (preforget) {
@@ -826,4 +829,8 @@
 {
 	ipc_phone_hangup(cap->kobject->phone);
+	kobject_t *kobj = cap_unpublish(cap->task, cap->handle,
+	    KOBJECT_TYPE_PHONE);
+	kobject_put(kobj);
+	cap_free(cap->task, cap->handle);
 	return true;
 }
Index: kernel/generic/src/ipc/irq.c
===================================================================
--- kernel/generic/src/ipc/irq.c	(revision 2b11c3c0cf74426080bd899202376055d7cb591d)
+++ kernel/generic/src/ipc/irq.c	(revision f834dd816464592376050320f24119ef2aabf8e8)
@@ -271,7 +271,24 @@
 }
 
+static void irq_hash_out(irq_t *irq)
+{
+	irq_spinlock_lock(&irq_uspace_hash_table_lock, true);
+	irq_spinlock_lock(&irq->lock, false);
+	
+	if (irq->notif_cfg.hashed_in) {
+		/* Remove the IRQ from the uspace IRQ hash table. */
+		hash_table_remove_item(&irq_uspace_hash_table, &irq->link);
+		irq->notif_cfg.hashed_in = false;
+	}
+
+	irq_spinlock_unlock(&irq->lock, false);
+	irq_spinlock_unlock(&irq_uspace_hash_table_lock, true);
+}
+
 static void irq_destroy(void *arg)
 {
 	irq_t *irq = (irq_t *) arg;
+
+	irq_hash_out(irq);
 
 	/* Free up the IRQ code and associated structures. */
@@ -373,16 +390,5 @@
 	assert(kobj->irq->notif_cfg.answerbox == box);
 
-	irq_spinlock_lock(&irq_uspace_hash_table_lock, true);
-	irq_spinlock_lock(&kobj->irq->lock, false);
-	
-	if (kobj->irq->notif_cfg.hashed_in) {
-		/* Remove the IRQ from the uspace IRQ hash table. */
-		hash_table_remove_item(&irq_uspace_hash_table,
-		    &kobj->irq->link);
-		kobj->irq->notif_cfg.hashed_in = false;
-	}
-
-	irq_spinlock_unlock(&kobj->irq->lock, false);
-	irq_spinlock_unlock(&irq_uspace_hash_table_lock, true);
+	irq_hash_out(kobj->irq);
 
 	kobject_put(kobj);
Index: kernel/generic/src/ipc/sysipc.c
===================================================================
--- kernel/generic/src/ipc/sysipc.c	(revision 2b11c3c0cf74426080bd899202376055d7cb591d)
+++ kernel/generic/src/ipc/sysipc.c	(revision f834dd816464592376050320f24119ef2aabf8e8)
@@ -199,4 +199,6 @@
 			irq_spinlock_lock(&phone->callee->lock, true);
 			list_remove(&phone->link);
+			/* Drop callee->connected_phones reference */
+			kobject_put(phone->kobject);
 			phone->state = IPC_PHONE_SLAMMED;
 			irq_spinlock_unlock(&phone->callee->lock, true);
Index: kernel/generic/src/ipc/sysipc_ops.c
===================================================================
--- kernel/generic/src/ipc/sysipc_ops.c	(revision 2b11c3c0cf74426080bd899202376055d7cb591d)
+++ kernel/generic/src/ipc/sysipc_ops.c	(revision f834dd816464592376050320f24119ef2aabf8e8)
@@ -38,13 +38,13 @@
 
 /* Forward declarations. */
-sysipc_ops_t ipc_m_connect_to_me_ops;
-sysipc_ops_t ipc_m_connect_me_to_ops;
-sysipc_ops_t ipc_m_page_in_ops;
-sysipc_ops_t ipc_m_share_out_ops;
-sysipc_ops_t ipc_m_share_in_ops;
-sysipc_ops_t ipc_m_data_write_ops;
-sysipc_ops_t ipc_m_data_read_ops;
-sysipc_ops_t ipc_m_state_change_authorize_ops;
-sysipc_ops_t ipc_m_debug_ops;
+extern sysipc_ops_t ipc_m_connect_to_me_ops;
+extern sysipc_ops_t ipc_m_connect_me_to_ops;
+extern sysipc_ops_t ipc_m_page_in_ops;
+extern sysipc_ops_t ipc_m_share_out_ops;
+extern sysipc_ops_t ipc_m_share_in_ops;
+extern sysipc_ops_t ipc_m_data_write_ops;
+extern sysipc_ops_t ipc_m_data_read_ops;
+extern sysipc_ops_t ipc_m_state_change_authorize_ops;
+extern sysipc_ops_t ipc_m_debug_ops;
 
 static sysipc_ops_t *sysipc_ops[] = {
Index: kernel/generic/src/lib/ra.c
===================================================================
--- kernel/generic/src/lib/ra.c	(revision 2b11c3c0cf74426080bd899202376055d7cb591d)
+++ kernel/generic/src/lib/ra.c	(revision f834dd816464592376050320f24119ef2aabf8e8)
@@ -353,6 +353,6 @@
 	link = hash_table_find(&span->used, &key);
 	if (!link) {
-		panic("Freeing segment which is not known to be used (base=%"
-		    PRIxn ", size=%" PRIdn ").", base, size);
+		panic("Freeing segment which is not known to be used (base=%zx"
+		    ", size=%zd).", base, size);
 	}
 	seg = hash_table_get_inst(link, ra_segment_t, uh_link);
@@ -447,5 +447,5 @@
 	irq_spinlock_unlock(&arena->lock, true);
 
-	panic("Freeing to wrong arena (base=%" PRIxn ", size=%" PRIdn ").",
+	panic("Freeing to wrong arena (base=%" PRIxPTR ", size=%zd).",
 	    base, size);
 }
Index: kernel/generic/src/lib/str.c
===================================================================
--- kernel/generic/src/lib/str.c	(revision 2b11c3c0cf74426080bd899202376055d7cb591d)
+++ kernel/generic/src/lib/str.c	(revision f834dd816464592376050320f24119ef2aabf8e8)
@@ -114,5 +114,5 @@
 
 /** Check the condition if wchar_t is signed */
-#ifdef WCHAR_IS_UNSIGNED
+#ifdef __WCHAR_UNSIGNED__
 	#define WCHAR_SIGNED_CHECK(cond)  (true)
 #else
Index: kernel/generic/src/mm/backend_user.c
===================================================================
--- kernel/generic/src/mm/backend_user.c	(revision 2b11c3c0cf74426080bd899202376055d7cb591d)
+++ kernel/generic/src/mm/backend_user.c	(revision f834dd816464592376050320f24119ef2aabf8e8)
@@ -129,5 +129,5 @@
 	if (rc != EOK) {
 		log(LF_USPACE, LVL_FATAL,
-		    "Page-in request for page %#" PRIxn
+		    "Page-in request for page %#" PRIxPTR
 		    " at pager %d failed with error %d.",
 		    upage, pager_info->pager, rc);
Index: kernel/generic/src/printf/printf_core.c
===================================================================
--- kernel/generic/src/printf/printf_core.c	(revision 2b11c3c0cf74426080bd899202376055d7cb591d)
+++ kernel/generic/src/printf/printf_core.c	(revision f834dd816464592376050320f24119ef2aabf8e8)
@@ -104,5 +104,6 @@
 	PrintfQualifierLongLong,
 	PrintfQualifierPointer,
-	PrintfQualifierSize
+	PrintfQualifierSize,
+	PrintfQualifierMax
 } qualifier_t;
 
@@ -767,4 +768,9 @@
 			case 'z':
 				qualifier = PrintfQualifierSize;
+				i = nxt;
+				uc = str_decode(fmt, &nxt, STR_NO_LIMIT);
+				break;
+			case 'j':
+				qualifier = PrintfQualifierMax;
 				i = nxt;
 				uc = str_decode(fmt, &nxt, STR_NO_LIMIT);
@@ -892,4 +898,8 @@
 				number = (uint64_t) va_arg(ap, size_t);
 				break;
+			case PrintfQualifierMax:
+				size = sizeof(uintmax_t);
+				number = (uint64_t) va_arg(ap, uintmax_t);
+				break;
 			default:
 				/* Unknown qualifier */
Index: kernel/generic/src/synch/mutex.c
===================================================================
--- kernel/generic/src/synch/mutex.c	(revision 2b11c3c0cf74426080bd899202376055d7cb591d)
+++ kernel/generic/src/synch/mutex.c	(revision f834dd816464592376050320f24119ef2aabf8e8)
@@ -46,10 +46,12 @@
 /** Initialize mutex.
  *
- * @param mtx  Mutex.
- * @param type Type of the mutex.
+ * @param mtx   Mutex.
+ * @param type  Type of the mutex.
  */
 void mutex_initialize(mutex_t *mtx, mutex_type_t type)
 {
 	mtx->type = type;
+	mtx->owner = NULL;
+	mtx->nesting = 0;
 	semaphore_initialize(&mtx->sem, 1);
 }
@@ -57,6 +59,7 @@
 /** Find out whether the mutex is currently locked.
  *
- * @param mtx		Mutex.
- * @return 		True if the mutex is locked, false otherwise.
+ * @param mtx  Mutex.
+ *
+ * @return  True if the mutex is locked, false otherwise.
  */
 bool mutex_locked(mutex_t *mtx)
@@ -71,10 +74,10 @@
  * Timeout mode and non-blocking mode can be requested.
  *
- * @param mtx   Mutex.
- * @param usec  Timeout in microseconds.
- * @param flags Specify mode of operation.
+ * @param mtx    Mutex.
+ * @param usec   Timeout in microseconds.
+ * @param flags  Specify mode of operation.
  *
- * For exact description of possible combinations of
- * usec and flags, see comment for waitq_sleep_timeout().
+ * For exact description of possible combinations of usec and flags, see
+ * comment for waitq_sleep_timeout().
  *
  * @return See comment for waitq_sleep_timeout().
@@ -85,8 +88,21 @@
 	int rc;
 
-	if ((mtx->type == MUTEX_PASSIVE) && (THREAD)) {
+	if (mtx->type == MUTEX_PASSIVE && THREAD) {
 		rc = _semaphore_down_timeout(&mtx->sem, usec, flags);
+	} else if (mtx->type == MUTEX_RECURSIVE) {
+		assert(THREAD);
+
+		if (mtx->owner == THREAD) {
+			mtx->nesting++;
+			return ESYNCH_OK_ATOMIC;
+		} else {
+			rc = _semaphore_down_timeout(&mtx->sem, usec, flags);
+			if (SYNCH_OK(rc)) {
+				mtx->owner = THREAD;
+				mtx->nesting = 1;
+			}
+		}
 	} else {
-		assert((mtx->type == MUTEX_ACTIVE) || (!THREAD));
+		assert((mtx->type == MUTEX_ACTIVE) || !THREAD);
 		assert(usec == SYNCH_NO_TIMEOUT);
 		assert(!(flags & SYNCH_FLAGS_INTERRUPTIBLE));
@@ -114,8 +130,14 @@
 /** Release mutex.
  *
- * @param mtx Mutex.
+ * @param mtx  Mutex.
  */
 void mutex_unlock(mutex_t *mtx)
 {
+	if (mtx->type == MUTEX_RECURSIVE) {
+		assert(mtx->owner == THREAD);
+		if (--mtx->nesting > 0)
+			return;
+		mtx->owner = NULL;
+	}
 	semaphore_up(&mtx->sem);
 }
